/*eslint-disable block-scoped-var, id-length, no-control-regex, no-magic-numbers, no-prototype-builtins, no-redeclare, no-shadow, no-var, sort-vars*/
"use strict";
var $protobuf = require("protobufjs/minimal");
// Common aliases
var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;
// Exported root namespace
var $root = $protobuf.roots.statuses || ($protobuf.roots.statuses = {});
$root.vereign = (function () {
    /**
     * Namespace vereign.
     * @exports vereign
     * @namespace
     */
    var vereign = {};
    vereign.statuses = (function () {
        /**
         * Namespace statuses.
         * @memberof vereign
         * @namespace
         */
        var statuses = {};
        /**
         * MessageSignatureHashingAlgorithm enum.
         * @name vereign.statuses.MessageSignatureHashingAlgorithm
         * @enum {number}
         * @property {number} MIME=0 MIME value
         * @property {number} PARTS=1 PARTS value
         */
        statuses.MessageSignatureHashingAlgorithm = (function () {
            var valuesById = {}, values = Object.create(valuesById);
            values[valuesById[0] = "MIME"] = 0;
            values[valuesById[1] = "PARTS"] = 1;
            return values;
        })();
        /**
         * SenderSystem enum.
         * @name vereign.statuses.SenderSystem
         * @enum {number}
         * @property {number} GMAIL=0 GMAIL value
         * @property {number} OUTLOOK=1 OUTLOOK value
         * @property {number} ROUNDCUBE=2 ROUNDCUBE value
         * @property {number} GENERIC_MIME=3 GENERIC_MIME value
         */
        statuses.SenderSystem = (function () {
            var valuesById = {}, values = Object.create(valuesById);
            values[valuesById[0] = "GMAIL"] = 0;
            values[valuesById[1] = "OUTLOOK"] = 1;
            values[valuesById[2] = "ROUNDCUBE"] = 2;
            values[valuesById[3] = "GENERIC_MIME"] = 3;
            return values;
        })();
        statuses.AttachmentSignature = (function () {
            /**
             * Properties of an AttachmentSignature.
             * @memberof vereign.statuses
             * @interface IAttachmentSignature
             * @property {Uint8Array|null} [value] AttachmentSignature value
             * @property {string|null} [preSignHashAlgorithm] AttachmentSignature preSignHashAlgorithm
             */
            /**
             * Constructs a new AttachmentSignature.
             * @memberof vereign.statuses
             * @classdesc Represents an AttachmentSignature.
             * @implements IAttachmentSignature
             * @constructor
             * @param {vereign.statuses.IAttachmentSignature=} [properties] Properties to set
             */
            function AttachmentSignature(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }
            /**
             * AttachmentSignature value.
             * @member {Uint8Array} value
             * @memberof vereign.statuses.AttachmentSignature
             * @instance
             */
            AttachmentSignature.prototype.value = $util.newBuffer([]);
            /**
             * AttachmentSignature preSignHashAlgorithm.
             * @member {string} preSignHashAlgorithm
             * @memberof vereign.statuses.AttachmentSignature
             * @instance
             */
            AttachmentSignature.prototype.preSignHashAlgorithm = "";
            /**
             * Creates a new AttachmentSignature instance using the specified properties.
             * @function create
             * @memberof vereign.statuses.AttachmentSignature
             * @static
             * @param {vereign.statuses.IAttachmentSignature=} [properties] Properties to set
             * @returns {vereign.statuses.AttachmentSignature} AttachmentSignature instance
             */
            AttachmentSignature.create = function create(properties) {
                return new AttachmentSignature(properties);
            };
            /**
             * Encodes the specified AttachmentSignature message. Does not implicitly {@link vereign.statuses.AttachmentSignature.verify|verify} messages.
             * @function encode
             * @memberof vereign.statuses.AttachmentSignature
             * @static
             * @param {vereign.statuses.IAttachmentSignature} message AttachmentSignature message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            AttachmentSignature.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                    writer.uint32(/* id 1, wireType 2 =*/ 10).bytes(message.value);
                if (message.preSignHashAlgorithm != null && Object.hasOwnProperty.call(message, "preSignHashAlgorithm"))
                    writer.uint32(/* id 2, wireType 2 =*/ 18).string(message.preSignHashAlgorithm);
                return writer;
            };
            /**
             * Encodes the specified AttachmentSignature message, length delimited. Does not implicitly {@link vereign.statuses.AttachmentSignature.verify|verify} messages.
             * @function encodeDelimited
             * @memberof vereign.statuses.AttachmentSignature
             * @static
             * @param {vereign.statuses.IAttachmentSignature} message AttachmentSignature message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            AttachmentSignature.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };
            /**
             * Decodes an AttachmentSignature message from the specified reader or buffer.
             * @function decode
             * @memberof vereign.statuses.AttachmentSignature
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {vereign.statuses.AttachmentSignature} AttachmentSignature
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            AttachmentSignature.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.statuses.AttachmentSignature();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                        case 1:
                            message.value = reader.bytes();
                            break;
                        case 2:
                            message.preSignHashAlgorithm = reader.string();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                    }
                }
                return message;
            };
            /**
             * Decodes an AttachmentSignature message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof vereign.statuses.AttachmentSignature
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {vereign.statuses.AttachmentSignature} AttachmentSignature
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            AttachmentSignature.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };
            /**
             * Verifies an AttachmentSignature message.
             * @function verify
             * @memberof vereign.statuses.AttachmentSignature
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            AttachmentSignature.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (!(message.value && typeof message.value.length === "number" || $util.isString(message.value)))
                        return "value: buffer expected";
                if (message.preSignHashAlgorithm != null && message.hasOwnProperty("preSignHashAlgorithm"))
                    if (!$util.isString(message.preSignHashAlgorithm))
                        return "preSignHashAlgorithm: string expected";
                return null;
            };
            /**
             * Creates an AttachmentSignature message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof vereign.statuses.AttachmentSignature
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {vereign.statuses.AttachmentSignature} AttachmentSignature
             */
            AttachmentSignature.fromObject = function fromObject(object) {
                if (object instanceof $root.vereign.statuses.AttachmentSignature)
                    return object;
                var message = new $root.vereign.statuses.AttachmentSignature();
                if (object.value != null)
                    if (typeof object.value === "string")
                        $util.base64.decode(object.value, message.value = $util.newBuffer($util.base64.length(object.value)), 0);
                    else if (object.value.length)
                        message.value = object.value;
                if (object.preSignHashAlgorithm != null)
                    message.preSignHashAlgorithm = String(object.preSignHashAlgorithm);
                return message;
            };
            /**
             * Creates a plain object from an AttachmentSignature message. Also converts values to other types if specified.
             * @function toObject
             * @memberof vereign.statuses.AttachmentSignature
             * @static
             * @param {vereign.statuses.AttachmentSignature} message AttachmentSignature
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            AttachmentSignature.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    if (options.bytes === String)
                        object.value = "";
                    else {
                        object.value = [];
                        if (options.bytes !== Array)
                            object.value = $util.newBuffer(object.value);
                    }
                    object.preSignHashAlgorithm = "";
                }
                if (message.value != null && message.hasOwnProperty("value"))
                    object.value = options.bytes === String ? $util.base64.encode(message.value, 0, message.value.length) : options.bytes === Array ? Array.prototype.slice.call(message.value) : message.value;
                if (message.preSignHashAlgorithm != null && message.hasOwnProperty("preSignHashAlgorithm"))
                    object.preSignHashAlgorithm = message.preSignHashAlgorithm;
                return object;
            };
            /**
             * Converts this AttachmentSignature to JSON.
             * @function toJSON
             * @memberof vereign.statuses.AttachmentSignature
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            AttachmentSignature.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };
            return AttachmentSignature;
        })();
        statuses.AttachmentSignatureList = (function () {
            /**
             * Properties of an AttachmentSignatureList.
             * @memberof vereign.statuses
             * @interface IAttachmentSignatureList
             * @property {Array.<vereign.statuses.IAttachmentSignature>|null} [list] AttachmentSignatureList list
             */
            /**
             * Constructs a new AttachmentSignatureList.
             * @memberof vereign.statuses
             * @classdesc Represents an AttachmentSignatureList.
             * @implements IAttachmentSignatureList
             * @constructor
             * @param {vereign.statuses.IAttachmentSignatureList=} [properties] Properties to set
             */
            function AttachmentSignatureList(properties) {
                this.list = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }
            /**
             * AttachmentSignatureList list.
             * @member {Array.<vereign.statuses.IAttachmentSignature>} list
             * @memberof vereign.statuses.AttachmentSignatureList
             * @instance
             */
            AttachmentSignatureList.prototype.list = $util.emptyArray;
            /**
             * Creates a new AttachmentSignatureList instance using the specified properties.
             * @function create
             * @memberof vereign.statuses.AttachmentSignatureList
             * @static
             * @param {vereign.statuses.IAttachmentSignatureList=} [properties] Properties to set
             * @returns {vereign.statuses.AttachmentSignatureList} AttachmentSignatureList instance
             */
            AttachmentSignatureList.create = function create(properties) {
                return new AttachmentSignatureList(properties);
            };
            /**
             * Encodes the specified AttachmentSignatureList message. Does not implicitly {@link vereign.statuses.AttachmentSignatureList.verify|verify} messages.
             * @function encode
             * @memberof vereign.statuses.AttachmentSignatureList
             * @static
             * @param {vereign.statuses.IAttachmentSignatureList} message AttachmentSignatureList message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            AttachmentSignatureList.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.list != null && message.list.length)
                    for (var i = 0; i < message.list.length; ++i)
                        $root.vereign.statuses.AttachmentSignature.encode(message.list[i], writer.uint32(/* id 1, wireType 2 =*/ 10).fork()).ldelim();
                return writer;
            };
            /**
             * Encodes the specified AttachmentSignatureList message, length delimited. Does not implicitly {@link vereign.statuses.AttachmentSignatureList.verify|verify} messages.
             * @function encodeDelimited
             * @memberof vereign.statuses.AttachmentSignatureList
             * @static
             * @param {vereign.statuses.IAttachmentSignatureList} message AttachmentSignatureList message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            AttachmentSignatureList.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };
            /**
             * Decodes an AttachmentSignatureList message from the specified reader or buffer.
             * @function decode
             * @memberof vereign.statuses.AttachmentSignatureList
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {vereign.statuses.AttachmentSignatureList} AttachmentSignatureList
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            AttachmentSignatureList.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.statuses.AttachmentSignatureList();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                        case 1:
                            if (!(message.list && message.list.length))
                                message.list = [];
                            message.list.push($root.vereign.statuses.AttachmentSignature.decode(reader, reader.uint32()));
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                    }
                }
                return message;
            };
            /**
             * Decodes an AttachmentSignatureList message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof vereign.statuses.AttachmentSignatureList
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {vereign.statuses.AttachmentSignatureList} AttachmentSignatureList
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            AttachmentSignatureList.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };
            /**
             * Verifies an AttachmentSignatureList message.
             * @function verify
             * @memberof vereign.statuses.AttachmentSignatureList
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            AttachmentSignatureList.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.list != null && message.hasOwnProperty("list")) {
                    if (!Array.isArray(message.list))
                        return "list: array expected";
                    for (var i = 0; i < message.list.length; ++i) {
                        var error = $root.vereign.statuses.AttachmentSignature.verify(message.list[i]);
                        if (error)
                            return "list." + error;
                    }
                }
                return null;
            };
            /**
             * Creates an AttachmentSignatureList message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof vereign.statuses.AttachmentSignatureList
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {vereign.statuses.AttachmentSignatureList} AttachmentSignatureList
             */
            AttachmentSignatureList.fromObject = function fromObject(object) {
                if (object instanceof $root.vereign.statuses.AttachmentSignatureList)
                    return object;
                var message = new $root.vereign.statuses.AttachmentSignatureList();
                if (object.list) {
                    if (!Array.isArray(object.list))
                        throw TypeError(".vereign.statuses.AttachmentSignatureList.list: array expected");
                    message.list = [];
                    for (var i = 0; i < object.list.length; ++i) {
                        if (typeof object.list[i] !== "object")
                            throw TypeError(".vereign.statuses.AttachmentSignatureList.list: object expected");
                        message.list[i] = $root.vereign.statuses.AttachmentSignature.fromObject(object.list[i]);
                    }
                }
                return message;
            };
            /**
             * Creates a plain object from an AttachmentSignatureList message. Also converts values to other types if specified.
             * @function toObject
             * @memberof vereign.statuses.AttachmentSignatureList
             * @static
             * @param {vereign.statuses.AttachmentSignatureList} message AttachmentSignatureList
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            AttachmentSignatureList.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.list = [];
                if (message.list && message.list.length) {
                    object.list = [];
                    for (var j = 0; j < message.list.length; ++j)
                        object.list[j] = $root.vereign.statuses.AttachmentSignature.toObject(message.list[j], options);
                }
                return object;
            };
            /**
             * Converts this AttachmentSignatureList to JSON.
             * @function toJSON
             * @memberof vereign.statuses.AttachmentSignatureList
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            AttachmentSignatureList.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };
            return AttachmentSignatureList;
        })();
        statuses.SenderStatusObject = (function () {
            /**
             * Properties of a SenderStatusObject.
             * @memberof vereign.statuses
             * @interface ISenderStatusObject
             * @property {number|Long|null} [signatureTime] SenderStatusObject signatureTime
             * @property {Uint8Array|null} [signatureTimeSignature] SenderStatusObject signatureTimeSignature
             * @property {Uint8Array|null} [messageSignature] SenderStatusObject messageSignature
             * @property {Object.<string,vereign.statuses.IAttachmentSignatureList>|null} [attachmentsSignatures] SenderStatusObject attachmentsSignatures
             * @property {vereign.statuses.MessageSignatureHashingAlgorithm|null} [messageSignatureHashingAlgorithm] SenderStatusObject messageSignatureHashingAlgorithm
             * @property {vereign.statuses.SenderSystem|null} [senderSystem] SenderStatusObject senderSystem
             * @property {Uint8Array|null} [sealSignature] SenderStatusObject sealSignature
             * @property {Uint8Array|null} [htmlPartsSignature] SenderStatusObject htmlPartsSignature
             * @property {Uint8Array|null} [plainPartsSignature] SenderStatusObject plainPartsSignature
             * @property {Uint8Array|null} [pseudoPlainPartsSignature] SenderStatusObject pseudoPlainPartsSignature
             * @property {Uint8Array|null} [sealHash] SenderStatusObject sealHash
             */
            /**
             * Constructs a new SenderStatusObject.
             * @memberof vereign.statuses
             * @classdesc Represents a SenderStatusObject.
             * @implements ISenderStatusObject
             * @constructor
             * @param {vereign.statuses.ISenderStatusObject=} [properties] Properties to set
             */
            function SenderStatusObject(properties) {
                this.attachmentsSignatures = {};
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }
            /**
             * SenderStatusObject signatureTime.
             * @member {number|Long} signatureTime
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.signatureTime = $util.Long ? $util.Long.fromBits(0, 0, false) : 0;
            /**
             * SenderStatusObject signatureTimeSignature.
             * @member {Uint8Array} signatureTimeSignature
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.signatureTimeSignature = $util.newBuffer([]);
            /**
             * SenderStatusObject messageSignature.
             * @member {Uint8Array} messageSignature
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.messageSignature = $util.newBuffer([]);
            /**
             * SenderStatusObject attachmentsSignatures.
             * @member {Object.<string,vereign.statuses.IAttachmentSignatureList>} attachmentsSignatures
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.attachmentsSignatures = $util.emptyObject;
            /**
             * SenderStatusObject messageSignatureHashingAlgorithm.
             * @member {vereign.statuses.MessageSignatureHashingAlgorithm} messageSignatureHashingAlgorithm
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.messageSignatureHashingAlgorithm = 0;
            /**
             * SenderStatusObject senderSystem.
             * @member {vereign.statuses.SenderSystem} senderSystem
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.senderSystem = 0;
            /**
             * SenderStatusObject sealSignature.
             * @member {Uint8Array} sealSignature
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.sealSignature = $util.newBuffer([]);
            /**
             * SenderStatusObject htmlPartsSignature.
             * @member {Uint8Array} htmlPartsSignature
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.htmlPartsSignature = $util.newBuffer([]);
            /**
             * SenderStatusObject plainPartsSignature.
             * @member {Uint8Array} plainPartsSignature
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.plainPartsSignature = $util.newBuffer([]);
            /**
             * SenderStatusObject pseudoPlainPartsSignature.
             * @member {Uint8Array} pseudoPlainPartsSignature
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.pseudoPlainPartsSignature = $util.newBuffer([]);
            /**
             * SenderStatusObject sealHash.
             * @member {Uint8Array} sealHash
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             */
            SenderStatusObject.prototype.sealHash = $util.newBuffer([]);
            /**
             * Creates a new SenderStatusObject instance using the specified properties.
             * @function create
             * @memberof vereign.statuses.SenderStatusObject
             * @static
             * @param {vereign.statuses.ISenderStatusObject=} [properties] Properties to set
             * @returns {vereign.statuses.SenderStatusObject} SenderStatusObject instance
             */
            SenderStatusObject.create = function create(properties) {
                return new SenderStatusObject(properties);
            };
            /**
             * Encodes the specified SenderStatusObject message. Does not implicitly {@link vereign.statuses.SenderStatusObject.verify|verify} messages.
             * @function encode
             * @memberof vereign.statuses.SenderStatusObject
             * @static
             * @param {vereign.statuses.ISenderStatusObject} message SenderStatusObject message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            SenderStatusObject.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.signatureTime != null && Object.hasOwnProperty.call(message, "signatureTime"))
                    writer.uint32(/* id 1, wireType 0 =*/ 8).int64(message.signatureTime);
                if (message.signatureTimeSignature != null && Object.hasOwnProperty.call(message, "signatureTimeSignature"))
                    writer.uint32(/* id 2, wireType 2 =*/ 18).bytes(message.signatureTimeSignature);
                if (message.messageSignature != null && Object.hasOwnProperty.call(message, "messageSignature"))
                    writer.uint32(/* id 3, wireType 2 =*/ 26).bytes(message.messageSignature);
                if (message.attachmentsSignatures != null && Object.hasOwnProperty.call(message, "attachmentsSignatures"))
                    for (var keys = Object.keys(message.attachmentsSignatures), i = 0; i < keys.length; ++i) {
                        writer.uint32(/* id 4, wireType 2 =*/ 34).fork().uint32(/* id 1, wireType 2 =*/ 10).string(keys[i]);
                        $root.vereign.statuses.AttachmentSignatureList.encode(message.attachmentsSignatures[keys[i]], writer.uint32(/* id 2, wireType 2 =*/ 18).fork()).ldelim().ldelim();
                    }
                if (message.messageSignatureHashingAlgorithm != null && Object.hasOwnProperty.call(message, "messageSignatureHashingAlgorithm"))
                    writer.uint32(/* id 5, wireType 0 =*/ 40).int32(message.messageSignatureHashingAlgorithm);
                if (message.senderSystem != null && Object.hasOwnProperty.call(message, "senderSystem"))
                    writer.uint32(/* id 6, wireType 0 =*/ 48).int32(message.senderSystem);
                if (message.sealSignature != null && Object.hasOwnProperty.call(message, "sealSignature"))
                    writer.uint32(/* id 7, wireType 2 =*/ 58).bytes(message.sealSignature);
                if (message.htmlPartsSignature != null && Object.hasOwnProperty.call(message, "htmlPartsSignature"))
                    writer.uint32(/* id 8, wireType 2 =*/ 66).bytes(message.htmlPartsSignature);
                if (message.plainPartsSignature != null && Object.hasOwnProperty.call(message, "plainPartsSignature"))
                    writer.uint32(/* id 9, wireType 2 =*/ 74).bytes(message.plainPartsSignature);
                if (message.pseudoPlainPartsSignature != null && Object.hasOwnProperty.call(message, "pseudoPlainPartsSignature"))
                    writer.uint32(/* id 10, wireType 2 =*/ 82).bytes(message.pseudoPlainPartsSignature);
                if (message.sealHash != null && Object.hasOwnProperty.call(message, "sealHash"))
                    writer.uint32(/* id 12, wireType 2 =*/ 98).bytes(message.sealHash);
                return writer;
            };
            /**
             * Encodes the specified SenderStatusObject message, length delimited. Does not implicitly {@link vereign.statuses.SenderStatusObject.verify|verify} messages.
             * @function encodeDelimited
             * @memberof vereign.statuses.SenderStatusObject
             * @static
             * @param {vereign.statuses.ISenderStatusObject} message SenderStatusObject message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            SenderStatusObject.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };
            /**
             * Decodes a SenderStatusObject message from the specified reader or buffer.
             * @function decode
             * @memberof vereign.statuses.SenderStatusObject
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {vereign.statuses.SenderStatusObject} SenderStatusObject
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            SenderStatusObject.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.statuses.SenderStatusObject(), key, value;
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                        case 1:
                            message.signatureTime = reader.int64();
                            break;
                        case 2:
                            message.signatureTimeSignature = reader.bytes();
                            break;
                        case 3:
                            message.messageSignature = reader.bytes();
                            break;
                        case 4:
                            if (message.attachmentsSignatures === $util.emptyObject)
                                message.attachmentsSignatures = {};
                            var end2 = reader.uint32() + reader.pos;
                            key = "";
                            value = null;
                            while (reader.pos < end2) {
                                var tag2 = reader.uint32();
                                switch (tag2 >>> 3) {
                                    case 1:
                                        key = reader.string();
                                        break;
                                    case 2:
                                        value = $root.vereign.statuses.AttachmentSignatureList.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag2 & 7);
                                        break;
                                }
                            }
                            message.attachmentsSignatures[key] = value;
                            break;
                        case 5:
                            message.messageSignatureHashingAlgorithm = reader.int32();
                            break;
                        case 6:
                            message.senderSystem = reader.int32();
                            break;
                        case 7:
                            message.sealSignature = reader.bytes();
                            break;
                        case 8:
                            message.htmlPartsSignature = reader.bytes();
                            break;
                        case 9:
                            message.plainPartsSignature = reader.bytes();
                            break;
                        case 10:
                            message.pseudoPlainPartsSignature = reader.bytes();
                            break;
                        case 12:
                            message.sealHash = reader.bytes();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                    }
                }
                return message;
            };
            /**
             * Decodes a SenderStatusObject message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof vereign.statuses.SenderStatusObject
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {vereign.statuses.SenderStatusObject} SenderStatusObject
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            SenderStatusObject.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };
            /**
             * Verifies a SenderStatusObject message.
             * @function verify
             * @memberof vereign.statuses.SenderStatusObject
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            SenderStatusObject.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.signatureTime != null && message.hasOwnProperty("signatureTime"))
                    if (!$util.isInteger(message.signatureTime) && !(message.signatureTime && $util.isInteger(message.signatureTime.low) && $util.isInteger(message.signatureTime.high)))
                        return "signatureTime: integer|Long expected";
                if (message.signatureTimeSignature != null && message.hasOwnProperty("signatureTimeSignature"))
                    if (!(message.signatureTimeSignature && typeof message.signatureTimeSignature.length === "number" || $util.isString(message.signatureTimeSignature)))
                        return "signatureTimeSignature: buffer expected";
                if (message.messageSignature != null && message.hasOwnProperty("messageSignature"))
                    if (!(message.messageSignature && typeof message.messageSignature.length === "number" || $util.isString(message.messageSignature)))
                        return "messageSignature: buffer expected";
                if (message.attachmentsSignatures != null && message.hasOwnProperty("attachmentsSignatures")) {
                    if (!$util.isObject(message.attachmentsSignatures))
                        return "attachmentsSignatures: object expected";
                    var key = Object.keys(message.attachmentsSignatures);
                    for (var i = 0; i < key.length; ++i) {
                        var error = $root.vereign.statuses.AttachmentSignatureList.verify(message.attachmentsSignatures[key[i]]);
                        if (error)
                            return "attachmentsSignatures." + error;
                    }
                }
                if (message.messageSignatureHashingAlgorithm != null && message.hasOwnProperty("messageSignatureHashingAlgorithm"))
                    switch (message.messageSignatureHashingAlgorithm) {
                        default:
                            return "messageSignatureHashingAlgorithm: enum value expected";
                        case 0:
                        case 1:
                            break;
                    }
                if (message.senderSystem != null && message.hasOwnProperty("senderSystem"))
                    switch (message.senderSystem) {
                        default:
                            return "senderSystem: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                        case 3:
                            break;
                    }
                if (message.sealSignature != null && message.hasOwnProperty("sealSignature"))
                    if (!(message.sealSignature && typeof message.sealSignature.length === "number" || $util.isString(message.sealSignature)))
                        return "sealSignature: buffer expected";
                if (message.htmlPartsSignature != null && message.hasOwnProperty("htmlPartsSignature"))
                    if (!(message.htmlPartsSignature && typeof message.htmlPartsSignature.length === "number" || $util.isString(message.htmlPartsSignature)))
                        return "htmlPartsSignature: buffer expected";
                if (message.plainPartsSignature != null && message.hasOwnProperty("plainPartsSignature"))
                    if (!(message.plainPartsSignature && typeof message.plainPartsSignature.length === "number" || $util.isString(message.plainPartsSignature)))
                        return "plainPartsSignature: buffer expected";
                if (message.pseudoPlainPartsSignature != null && message.hasOwnProperty("pseudoPlainPartsSignature"))
                    if (!(message.pseudoPlainPartsSignature && typeof message.pseudoPlainPartsSignature.length === "number" || $util.isString(message.pseudoPlainPartsSignature)))
                        return "pseudoPlainPartsSignature: buffer expected";
                if (message.sealHash != null && message.hasOwnProperty("sealHash"))
                    if (!(message.sealHash && typeof message.sealHash.length === "number" || $util.isString(message.sealHash)))
                        return "sealHash: buffer expected";
                return null;
            };
            /**
             * Creates a SenderStatusObject message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof vereign.statuses.SenderStatusObject
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {vereign.statuses.SenderStatusObject} SenderStatusObject
             */
            SenderStatusObject.fromObject = function fromObject(object) {
                if (object instanceof $root.vereign.statuses.SenderStatusObject)
                    return object;
                var message = new $root.vereign.statuses.SenderStatusObject();
                if (object.signatureTime != null)
                    if ($util.Long)
                        (message.signatureTime = $util.Long.fromValue(object.signatureTime)).unsigned = false;
                    else if (typeof object.signatureTime === "string")
                        message.signatureTime = parseInt(object.signatureTime, 10);
                    else if (typeof object.signatureTime === "number")
                        message.signatureTime = object.signatureTime;
                    else if (typeof object.signatureTime === "object")
                        message.signatureTime = new $util.LongBits(object.signatureTime.low >>> 0, object.signatureTime.high >>> 0).toNumber();
                if (object.signatureTimeSignature != null)
                    if (typeof object.signatureTimeSignature === "string")
                        $util.base64.decode(object.signatureTimeSignature, message.signatureTimeSignature = $util.newBuffer($util.base64.length(object.signatureTimeSignature)), 0);
                    else if (object.signatureTimeSignature.length)
                        message.signatureTimeSignature = object.signatureTimeSignature;
                if (object.messageSignature != null)
                    if (typeof object.messageSignature === "string")
                        $util.base64.decode(object.messageSignature, message.messageSignature = $util.newBuffer($util.base64.length(object.messageSignature)), 0);
                    else if (object.messageSignature.length)
                        message.messageSignature = object.messageSignature;
                if (object.attachmentsSignatures) {
                    if (typeof object.attachmentsSignatures !== "object")
                        throw TypeError(".vereign.statuses.SenderStatusObject.attachmentsSignatures: object expected");
                    message.attachmentsSignatures = {};
                    for (var keys = Object.keys(object.attachmentsSignatures), i = 0; i < keys.length; ++i) {
                        if (typeof object.attachmentsSignatures[keys[i]] !== "object")
                            throw TypeError(".vereign.statuses.SenderStatusObject.attachmentsSignatures: object expected");
                        message.attachmentsSignatures[keys[i]] = $root.vereign.statuses.AttachmentSignatureList.fromObject(object.attachmentsSignatures[keys[i]]);
                    }
                }
                switch (object.messageSignatureHashingAlgorithm) {
                    case "MIME":
                    case 0:
                        message.messageSignatureHashingAlgorithm = 0;
                        break;
                    case "PARTS":
                    case 1:
                        message.messageSignatureHashingAlgorithm = 1;
                        break;
                }
                switch (object.senderSystem) {
                    case "GMAIL":
                    case 0:
                        message.senderSystem = 0;
                        break;
                    case "OUTLOOK":
                    case 1:
                        message.senderSystem = 1;
                        break;
                    case "ROUNDCUBE":
                    case 2:
                        message.senderSystem = 2;
                        break;
                    case "GENERIC_MIME":
                    case 3:
                        message.senderSystem = 3;
                        break;
                }
                if (object.sealSignature != null)
                    if (typeof object.sealSignature === "string")
                        $util.base64.decode(object.sealSignature, message.sealSignature = $util.newBuffer($util.base64.length(object.sealSignature)), 0);
                    else if (object.sealSignature.length)
                        message.sealSignature = object.sealSignature;
                if (object.htmlPartsSignature != null)
                    if (typeof object.htmlPartsSignature === "string")
                        $util.base64.decode(object.htmlPartsSignature, message.htmlPartsSignature = $util.newBuffer($util.base64.length(object.htmlPartsSignature)), 0);
                    else if (object.htmlPartsSignature.length)
                        message.htmlPartsSignature = object.htmlPartsSignature;
                if (object.plainPartsSignature != null)
                    if (typeof object.plainPartsSignature === "string")
                        $util.base64.decode(object.plainPartsSignature, message.plainPartsSignature = $util.newBuffer($util.base64.length(object.plainPartsSignature)), 0);
                    else if (object.plainPartsSignature.length)
                        message.plainPartsSignature = object.plainPartsSignature;
                if (object.pseudoPlainPartsSignature != null)
                    if (typeof object.pseudoPlainPartsSignature === "string")
                        $util.base64.decode(object.pseudoPlainPartsSignature, message.pseudoPlainPartsSignature = $util.newBuffer($util.base64.length(object.pseudoPlainPartsSignature)), 0);
                    else if (object.pseudoPlainPartsSignature.length)
                        message.pseudoPlainPartsSignature = object.pseudoPlainPartsSignature;
                if (object.sealHash != null)
                    if (typeof object.sealHash === "string")
                        $util.base64.decode(object.sealHash, message.sealHash = $util.newBuffer($util.base64.length(object.sealHash)), 0);
                    else if (object.sealHash.length)
                        message.sealHash = object.sealHash;
                return message;
            };
            /**
             * Creates a plain object from a SenderStatusObject message. Also converts values to other types if specified.
             * @function toObject
             * @memberof vereign.statuses.SenderStatusObject
             * @static
             * @param {vereign.statuses.SenderStatusObject} message SenderStatusObject
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            SenderStatusObject.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.objects || options.defaults)
                    object.attachmentsSignatures = {};
                if (options.defaults) {
                    if ($util.Long) {
                        var long = new $util.Long(0, 0, false);
                        object.signatureTime = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                    }
                    else
                        object.signatureTime = options.longs === String ? "0" : 0;
                    if (options.bytes === String)
                        object.signatureTimeSignature = "";
                    else {
                        object.signatureTimeSignature = [];
                        if (options.bytes !== Array)
                            object.signatureTimeSignature = $util.newBuffer(object.signatureTimeSignature);
                    }
                    if (options.bytes === String)
                        object.messageSignature = "";
                    else {
                        object.messageSignature = [];
                        if (options.bytes !== Array)
                            object.messageSignature = $util.newBuffer(object.messageSignature);
                    }
                    object.messageSignatureHashingAlgorithm = options.enums === String ? "MIME" : 0;
                    object.senderSystem = options.enums === String ? "GMAIL" : 0;
                    if (options.bytes === String)
                        object.sealSignature = "";
                    else {
                        object.sealSignature = [];
                        if (options.bytes !== Array)
                            object.sealSignature = $util.newBuffer(object.sealSignature);
                    }
                    if (options.bytes === String)
                        object.htmlPartsSignature = "";
                    else {
                        object.htmlPartsSignature = [];
                        if (options.bytes !== Array)
                            object.htmlPartsSignature = $util.newBuffer(object.htmlPartsSignature);
                    }
                    if (options.bytes === String)
                        object.plainPartsSignature = "";
                    else {
                        object.plainPartsSignature = [];
                        if (options.bytes !== Array)
                            object.plainPartsSignature = $util.newBuffer(object.plainPartsSignature);
                    }
                    if (options.bytes === String)
                        object.pseudoPlainPartsSignature = "";
                    else {
                        object.pseudoPlainPartsSignature = [];
                        if (options.bytes !== Array)
                            object.pseudoPlainPartsSignature = $util.newBuffer(object.pseudoPlainPartsSignature);
                    }
                    if (options.bytes === String)
                        object.sealHash = "";
                    else {
                        object.sealHash = [];
                        if (options.bytes !== Array)
                            object.sealHash = $util.newBuffer(object.sealHash);
                    }
                }
                if (message.signatureTime != null && message.hasOwnProperty("signatureTime"))
                    if (typeof message.signatureTime === "number")
                        object.signatureTime = options.longs === String ? String(message.signatureTime) : message.signatureTime;
                    else
                        object.signatureTime = options.longs === String ? $util.Long.prototype.toString.call(message.signatureTime) : options.longs === Number ? new $util.LongBits(message.signatureTime.low >>> 0, message.signatureTime.high >>> 0).toNumber() : message.signatureTime;
                if (message.signatureTimeSignature != null && message.hasOwnProperty("signatureTimeSignature"))
                    object.signatureTimeSignature = options.bytes === String ? $util.base64.encode(message.signatureTimeSignature, 0, message.signatureTimeSignature.length) : options.bytes === Array ? Array.prototype.slice.call(message.signatureTimeSignature) : message.signatureTimeSignature;
                if (message.messageSignature != null && message.hasOwnProperty("messageSignature"))
                    object.messageSignature = options.bytes === String ? $util.base64.encode(message.messageSignature, 0, message.messageSignature.length) : options.bytes === Array ? Array.prototype.slice.call(message.messageSignature) : message.messageSignature;
                var keys2;
                if (message.attachmentsSignatures && (keys2 = Object.keys(message.attachmentsSignatures)).length) {
                    object.attachmentsSignatures = {};
                    for (var j = 0; j < keys2.length; ++j)
                        object.attachmentsSignatures[keys2[j]] = $root.vereign.statuses.AttachmentSignatureList.toObject(message.attachmentsSignatures[keys2[j]], options);
                }
                if (message.messageSignatureHashingAlgorithm != null && message.hasOwnProperty("messageSignatureHashingAlgorithm"))
                    object.messageSignatureHashingAlgorithm = options.enums === String ? $root.vereign.statuses.MessageSignatureHashingAlgorithm[message.messageSignatureHashingAlgorithm] : message.messageSignatureHashingAlgorithm;
                if (message.senderSystem != null && message.hasOwnProperty("senderSystem"))
                    object.senderSystem = options.enums === String ? $root.vereign.statuses.SenderSystem[message.senderSystem] : message.senderSystem;
                if (message.sealSignature != null && message.hasOwnProperty("sealSignature"))
                    object.sealSignature = options.bytes === String ? $util.base64.encode(message.sealSignature, 0, message.sealSignature.length) : options.bytes === Array ? Array.prototype.slice.call(message.sealSignature) : message.sealSignature;
                if (message.htmlPartsSignature != null && message.hasOwnProperty("htmlPartsSignature"))
                    object.htmlPartsSignature = options.bytes === String ? $util.base64.encode(message.htmlPartsSignature, 0, message.htmlPartsSignature.length) : options.bytes === Array ? Array.prototype.slice.call(message.htmlPartsSignature) : message.htmlPartsSignature;
                if (message.plainPartsSignature != null && message.hasOwnProperty("plainPartsSignature"))
                    object.plainPartsSignature = options.bytes === String ? $util.base64.encode(message.plainPartsSignature, 0, message.plainPartsSignature.length) : options.bytes === Array ? Array.prototype.slice.call(message.plainPartsSignature) : message.plainPartsSignature;
                if (message.pseudoPlainPartsSignature != null && message.hasOwnProperty("pseudoPlainPartsSignature"))
                    object.pseudoPlainPartsSignature = options.bytes === String ? $util.base64.encode(message.pseudoPlainPartsSignature, 0, message.pseudoPlainPartsSignature.length) : options.bytes === Array ? Array.prototype.slice.call(message.pseudoPlainPartsSignature) : message.pseudoPlainPartsSignature;
                if (message.sealHash != null && message.hasOwnProperty("sealHash"))
                    object.sealHash = options.bytes === String ? $util.base64.encode(message.sealHash, 0, message.sealHash.length) : options.bytes === Array ? Array.prototype.slice.call(message.sealHash) : message.sealHash;
                return object;
            };
            /**
             * Converts this SenderStatusObject to JSON.
             * @function toJSON
             * @memberof vereign.statuses.SenderStatusObject
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            SenderStatusObject.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };
            return SenderStatusObject;
        })();
        statuses.RecipientStatusData = (function () {
            /**
             * Properties of a RecipientStatusData.
             * @memberof vereign.statuses
             * @interface IRecipientStatusData
             * @property {number|Long|null} [creationDate] RecipientStatusData creationDate
             * @property {Uint8Array|null} [gatewayDomainHash] RecipientStatusData gatewayDomainHash
             * @property {Uint8Array|null} [randomToken] RecipientStatusData randomToken
             * @property {Uint8Array|null} [emailHash] RecipientStatusData emailHash
             */
            /**
             * Constructs a new RecipientStatusData.
             * @memberof vereign.statuses
             * @classdesc Represents a RecipientStatusData.
             * @implements IRecipientStatusData
             * @constructor
             * @param {vereign.statuses.IRecipientStatusData=} [properties] Properties to set
             */
            function RecipientStatusData(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }
            /**
             * RecipientStatusData creationDate.
             * @member {number|Long} creationDate
             * @memberof vereign.statuses.RecipientStatusData
             * @instance
             */
            RecipientStatusData.prototype.creationDate = $util.Long ? $util.Long.fromBits(0, 0, false) : 0;
            /**
             * RecipientStatusData gatewayDomainHash.
             * @member {Uint8Array} gatewayDomainHash
             * @memberof vereign.statuses.RecipientStatusData
             * @instance
             */
            RecipientStatusData.prototype.gatewayDomainHash = $util.newBuffer([]);
            /**
             * RecipientStatusData randomToken.
             * @member {Uint8Array} randomToken
             * @memberof vereign.statuses.RecipientStatusData
             * @instance
             */
            RecipientStatusData.prototype.randomToken = $util.newBuffer([]);
            /**
             * RecipientStatusData emailHash.
             * @member {Uint8Array} emailHash
             * @memberof vereign.statuses.RecipientStatusData
             * @instance
             */
            RecipientStatusData.prototype.emailHash = $util.newBuffer([]);
            /**
             * Creates a new RecipientStatusData instance using the specified properties.
             * @function create
             * @memberof vereign.statuses.RecipientStatusData
             * @static
             * @param {vereign.statuses.IRecipientStatusData=} [properties] Properties to set
             * @returns {vereign.statuses.RecipientStatusData} RecipientStatusData instance
             */
            RecipientStatusData.create = function create(properties) {
                return new RecipientStatusData(properties);
            };
            /**
             * Encodes the specified RecipientStatusData message. Does not implicitly {@link vereign.statuses.RecipientStatusData.verify|verify} messages.
             * @function encode
             * @memberof vereign.statuses.RecipientStatusData
             * @static
             * @param {vereign.statuses.IRecipientStatusData} message RecipientStatusData message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            RecipientStatusData.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.creationDate != null && Object.hasOwnProperty.call(message, "creationDate"))
                    writer.uint32(/* id 1, wireType 0 =*/ 8).int64(message.creationDate);
                if (message.gatewayDomainHash != null && Object.hasOwnProperty.call(message, "gatewayDomainHash"))
                    writer.uint32(/* id 2, wireType 2 =*/ 18).bytes(message.gatewayDomainHash);
                if (message.randomToken != null && Object.hasOwnProperty.call(message, "randomToken"))
                    writer.uint32(/* id 3, wireType 2 =*/ 26).bytes(message.randomToken);
                if (message.emailHash != null && Object.hasOwnProperty.call(message, "emailHash"))
                    writer.uint32(/* id 4, wireType 2 =*/ 34).bytes(message.emailHash);
                return writer;
            };
            /**
             * Encodes the specified RecipientStatusData message, length delimited. Does not implicitly {@link vereign.statuses.RecipientStatusData.verify|verify} messages.
             * @function encodeDelimited
             * @memberof vereign.statuses.RecipientStatusData
             * @static
             * @param {vereign.statuses.IRecipientStatusData} message RecipientStatusData message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            RecipientStatusData.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };
            /**
             * Decodes a RecipientStatusData message from the specified reader or buffer.
             * @function decode
             * @memberof vereign.statuses.RecipientStatusData
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {vereign.statuses.RecipientStatusData} RecipientStatusData
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            RecipientStatusData.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.statuses.RecipientStatusData();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                        case 1:
                            message.creationDate = reader.int64();
                            break;
                        case 2:
                            message.gatewayDomainHash = reader.bytes();
                            break;
                        case 3:
                            message.randomToken = reader.bytes();
                            break;
                        case 4:
                            message.emailHash = reader.bytes();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                    }
                }
                return message;
            };
            /**
             * Decodes a RecipientStatusData message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof vereign.statuses.RecipientStatusData
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {vereign.statuses.RecipientStatusData} RecipientStatusData
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            RecipientStatusData.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };
            /**
             * Verifies a RecipientStatusData message.
             * @function verify
             * @memberof vereign.statuses.RecipientStatusData
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            RecipientStatusData.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.creationDate != null && message.hasOwnProperty("creationDate"))
                    if (!$util.isInteger(message.creationDate) && !(message.creationDate && $util.isInteger(message.creationDate.low) && $util.isInteger(message.creationDate.high)))
                        return "creationDate: integer|Long expected";
                if (message.gatewayDomainHash != null && message.hasOwnProperty("gatewayDomainHash"))
                    if (!(message.gatewayDomainHash && typeof message.gatewayDomainHash.length === "number" || $util.isString(message.gatewayDomainHash)))
                        return "gatewayDomainHash: buffer expected";
                if (message.randomToken != null && message.hasOwnProperty("randomToken"))
                    if (!(message.randomToken && typeof message.randomToken.length === "number" || $util.isString(message.randomToken)))
                        return "randomToken: buffer expected";
                if (message.emailHash != null && message.hasOwnProperty("emailHash"))
                    if (!(message.emailHash && typeof message.emailHash.length === "number" || $util.isString(message.emailHash)))
                        return "emailHash: buffer expected";
                return null;
            };
            /**
             * Creates a RecipientStatusData message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof vereign.statuses.RecipientStatusData
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {vereign.statuses.RecipientStatusData} RecipientStatusData
             */
            RecipientStatusData.fromObject = function fromObject(object) {
                if (object instanceof $root.vereign.statuses.RecipientStatusData)
                    return object;
                var message = new $root.vereign.statuses.RecipientStatusData();
                if (object.creationDate != null)
                    if ($util.Long)
                        (message.creationDate = $util.Long.fromValue(object.creationDate)).unsigned = false;
                    else if (typeof object.creationDate === "string")
                        message.creationDate = parseInt(object.creationDate, 10);
                    else if (typeof object.creationDate === "number")
                        message.creationDate = object.creationDate;
                    else if (typeof object.creationDate === "object")
                        message.creationDate = new $util.LongBits(object.creationDate.low >>> 0, object.creationDate.high >>> 0).toNumber();
                if (object.gatewayDomainHash != null)
                    if (typeof object.gatewayDomainHash === "string")
                        $util.base64.decode(object.gatewayDomainHash, message.gatewayDomainHash = $util.newBuffer($util.base64.length(object.gatewayDomainHash)), 0);
                    else if (object.gatewayDomainHash.length)
                        message.gatewayDomainHash = object.gatewayDomainHash;
                if (object.randomToken != null)
                    if (typeof object.randomToken === "string")
                        $util.base64.decode(object.randomToken, message.randomToken = $util.newBuffer($util.base64.length(object.randomToken)), 0);
                    else if (object.randomToken.length)
                        message.randomToken = object.randomToken;
                if (object.emailHash != null)
                    if (typeof object.emailHash === "string")
                        $util.base64.decode(object.emailHash, message.emailHash = $util.newBuffer($util.base64.length(object.emailHash)), 0);
                    else if (object.emailHash.length)
                        message.emailHash = object.emailHash;
                return message;
            };
            /**
             * Creates a plain object from a RecipientStatusData message. Also converts values to other types if specified.
             * @function toObject
             * @memberof vereign.statuses.RecipientStatusData
             * @static
             * @param {vereign.statuses.RecipientStatusData} message RecipientStatusData
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            RecipientStatusData.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    if ($util.Long) {
                        var long = new $util.Long(0, 0, false);
                        object.creationDate = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                    }
                    else
                        object.creationDate = options.longs === String ? "0" : 0;
                    if (options.bytes === String)
                        object.gatewayDomainHash = "";
                    else {
                        object.gatewayDomainHash = [];
                        if (options.bytes !== Array)
                            object.gatewayDomainHash = $util.newBuffer(object.gatewayDomainHash);
                    }
                    if (options.bytes === String)
                        object.randomToken = "";
                    else {
                        object.randomToken = [];
                        if (options.bytes !== Array)
                            object.randomToken = $util.newBuffer(object.randomToken);
                    }
                    if (options.bytes === String)
                        object.emailHash = "";
                    else {
                        object.emailHash = [];
                        if (options.bytes !== Array)
                            object.emailHash = $util.newBuffer(object.emailHash);
                    }
                }
                if (message.creationDate != null && message.hasOwnProperty("creationDate"))
                    if (typeof message.creationDate === "number")
                        object.creationDate = options.longs === String ? String(message.creationDate) : message.creationDate;
                    else
                        object.creationDate = options.longs === String ? $util.Long.prototype.toString.call(message.creationDate) : options.longs === Number ? new $util.LongBits(message.creationDate.low >>> 0, message.creationDate.high >>> 0).toNumber() : message.creationDate;
                if (message.gatewayDomainHash != null && message.hasOwnProperty("gatewayDomainHash"))
                    object.gatewayDomainHash = options.bytes === String ? $util.base64.encode(message.gatewayDomainHash, 0, message.gatewayDomainHash.length) : options.bytes === Array ? Array.prototype.slice.call(message.gatewayDomainHash) : message.gatewayDomainHash;
                if (message.randomToken != null && message.hasOwnProperty("randomToken"))
                    object.randomToken = options.bytes === String ? $util.base64.encode(message.randomToken, 0, message.randomToken.length) : options.bytes === Array ? Array.prototype.slice.call(message.randomToken) : message.randomToken;
                if (message.emailHash != null && message.hasOwnProperty("emailHash"))
                    object.emailHash = options.bytes === String ? $util.base64.encode(message.emailHash, 0, message.emailHash.length) : options.bytes === Array ? Array.prototype.slice.call(message.emailHash) : message.emailHash;
                return object;
            };
            /**
             * Converts this RecipientStatusData to JSON.
             * @function toJSON
             * @memberof vereign.statuses.RecipientStatusData
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            RecipientStatusData.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };
            return RecipientStatusData;
        })();
        statuses.RecipientStatusObject = (function () {
            /**
             * Properties of a RecipientStatusObject.
             * @memberof vereign.statuses
             * @interface IRecipientStatusObject
             * @property {Uint8Array|null} [iv] RecipientStatusObject iv
             * @property {Uint8Array|null} [encryptedContent] RecipientStatusObject encryptedContent
             * @property {Object.<string,Uint8Array>|null} [decryptors] RecipientStatusObject decryptors
             */
            /**
             * Constructs a new RecipientStatusObject.
             * @memberof vereign.statuses
             * @classdesc Represents a RecipientStatusObject.
             * @implements IRecipientStatusObject
             * @constructor
             * @param {vereign.statuses.IRecipientStatusObject=} [properties] Properties to set
             */
            function RecipientStatusObject(properties) {
                this.decryptors = {};
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }
            /**
             * RecipientStatusObject iv.
             * @member {Uint8Array} iv
             * @memberof vereign.statuses.RecipientStatusObject
             * @instance
             */
            RecipientStatusObject.prototype.iv = $util.newBuffer([]);
            /**
             * RecipientStatusObject encryptedContent.
             * @member {Uint8Array} encryptedContent
             * @memberof vereign.statuses.RecipientStatusObject
             * @instance
             */
            RecipientStatusObject.prototype.encryptedContent = $util.newBuffer([]);
            /**
             * RecipientStatusObject decryptors.
             * @member {Object.<string,Uint8Array>} decryptors
             * @memberof vereign.statuses.RecipientStatusObject
             * @instance
             */
            RecipientStatusObject.prototype.decryptors = $util.emptyObject;
            /**
             * Creates a new RecipientStatusObject instance using the specified properties.
             * @function create
             * @memberof vereign.statuses.RecipientStatusObject
             * @static
             * @param {vereign.statuses.IRecipientStatusObject=} [properties] Properties to set
             * @returns {vereign.statuses.RecipientStatusObject} RecipientStatusObject instance
             */
            RecipientStatusObject.create = function create(properties) {
                return new RecipientStatusObject(properties);
            };
            /**
             * Encodes the specified RecipientStatusObject message. Does not implicitly {@link vereign.statuses.RecipientStatusObject.verify|verify} messages.
             * @function encode
             * @memberof vereign.statuses.RecipientStatusObject
             * @static
             * @param {vereign.statuses.IRecipientStatusObject} message RecipientStatusObject message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            RecipientStatusObject.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.iv != null && Object.hasOwnProperty.call(message, "iv"))
                    writer.uint32(/* id 1, wireType 2 =*/ 10).bytes(message.iv);
                if (message.encryptedContent != null && Object.hasOwnProperty.call(message, "encryptedContent"))
                    writer.uint32(/* id 2, wireType 2 =*/ 18).bytes(message.encryptedContent);
                if (message.decryptors != null && Object.hasOwnProperty.call(message, "decryptors"))
                    for (var keys = Object.keys(message.decryptors), i = 0; i < keys.length; ++i)
                        writer.uint32(/* id 3, wireType 2 =*/ 26).fork().uint32(/* id 1, wireType 2 =*/ 10).string(keys[i]).uint32(/* id 2, wireType 2 =*/ 18).bytes(message.decryptors[keys[i]]).ldelim();
                return writer;
            };
            /**
             * Encodes the specified RecipientStatusObject message, length delimited. Does not implicitly {@link vereign.statuses.RecipientStatusObject.verify|verify} messages.
             * @function encodeDelimited
             * @memberof vereign.statuses.RecipientStatusObject
             * @static
             * @param {vereign.statuses.IRecipientStatusObject} message RecipientStatusObject message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            RecipientStatusObject.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };
            /**
             * Decodes a RecipientStatusObject message from the specified reader or buffer.
             * @function decode
             * @memberof vereign.statuses.RecipientStatusObject
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {vereign.statuses.RecipientStatusObject} RecipientStatusObject
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            RecipientStatusObject.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.statuses.RecipientStatusObject(), key, value;
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                        case 1:
                            message.iv = reader.bytes();
                            break;
                        case 2:
                            message.encryptedContent = reader.bytes();
                            break;
                        case 3:
                            if (message.decryptors === $util.emptyObject)
                                message.decryptors = {};
                            var end2 = reader.uint32() + reader.pos;
                            key = "";
                            value = [];
                            while (reader.pos < end2) {
                                var tag2 = reader.uint32();
                                switch (tag2 >>> 3) {
                                    case 1:
                                        key = reader.string();
                                        break;
                                    case 2:
                                        value = reader.bytes();
                                        break;
                                    default:
                                        reader.skipType(tag2 & 7);
                                        break;
                                }
                            }
                            message.decryptors[key] = value;
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                    }
                }
                return message;
            };
            /**
             * Decodes a RecipientStatusObject message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof vereign.statuses.RecipientStatusObject
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {vereign.statuses.RecipientStatusObject} RecipientStatusObject
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            RecipientStatusObject.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };
            /**
             * Verifies a RecipientStatusObject message.
             * @function verify
             * @memberof vereign.statuses.RecipientStatusObject
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            RecipientStatusObject.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.iv != null && message.hasOwnProperty("iv"))
                    if (!(message.iv && typeof message.iv.length === "number" || $util.isString(message.iv)))
                        return "iv: buffer expected";
                if (message.encryptedContent != null && message.hasOwnProperty("encryptedContent"))
                    if (!(message.encryptedContent && typeof message.encryptedContent.length === "number" || $util.isString(message.encryptedContent)))
                        return "encryptedContent: buffer expected";
                if (message.decryptors != null && message.hasOwnProperty("decryptors")) {
                    if (!$util.isObject(message.decryptors))
                        return "decryptors: object expected";
                    var key = Object.keys(message.decryptors);
                    for (var i = 0; i < key.length; ++i)
                        if (!(message.decryptors[key[i]] && typeof message.decryptors[key[i]].length === "number" || $util.isString(message.decryptors[key[i]])))
                            return "decryptors: buffer{k:string} expected";
                }
                return null;
            };
            /**
             * Creates a RecipientStatusObject message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof vereign.statuses.RecipientStatusObject
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {vereign.statuses.RecipientStatusObject} RecipientStatusObject
             */
            RecipientStatusObject.fromObject = function fromObject(object) {
                if (object instanceof $root.vereign.statuses.RecipientStatusObject)
                    return object;
                var message = new $root.vereign.statuses.RecipientStatusObject();
                if (object.iv != null)
                    if (typeof object.iv === "string")
                        $util.base64.decode(object.iv, message.iv = $util.newBuffer($util.base64.length(object.iv)), 0);
                    else if (object.iv.length)
                        message.iv = object.iv;
                if (object.encryptedContent != null)
                    if (typeof object.encryptedContent === "string")
                        $util.base64.decode(object.encryptedContent, message.encryptedContent = $util.newBuffer($util.base64.length(object.encryptedContent)), 0);
                    else if (object.encryptedContent.length)
                        message.encryptedContent = object.encryptedContent;
                if (object.decryptors) {
                    if (typeof object.decryptors !== "object")
                        throw TypeError(".vereign.statuses.RecipientStatusObject.decryptors: object expected");
                    message.decryptors = {};
                    for (var keys = Object.keys(object.decryptors), i = 0; i < keys.length; ++i)
                        if (typeof object.decryptors[keys[i]] === "string")
                            $util.base64.decode(object.decryptors[keys[i]], message.decryptors[keys[i]] = $util.newBuffer($util.base64.length(object.decryptors[keys[i]])), 0);
                        else if (object.decryptors[keys[i]].length)
                            message.decryptors[keys[i]] = object.decryptors[keys[i]];
                }
                return message;
            };
            /**
             * Creates a plain object from a RecipientStatusObject message. Also converts values to other types if specified.
             * @function toObject
             * @memberof vereign.statuses.RecipientStatusObject
             * @static
             * @param {vereign.statuses.RecipientStatusObject} message RecipientStatusObject
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            RecipientStatusObject.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.objects || options.defaults)
                    object.decryptors = {};
                if (options.defaults) {
                    if (options.bytes === String)
                        object.iv = "";
                    else {
                        object.iv = [];
                        if (options.bytes !== Array)
                            object.iv = $util.newBuffer(object.iv);
                    }
                    if (options.bytes === String)
                        object.encryptedContent = "";
                    else {
                        object.encryptedContent = [];
                        if (options.bytes !== Array)
                            object.encryptedContent = $util.newBuffer(object.encryptedContent);
                    }
                }
                if (message.iv != null && message.hasOwnProperty("iv"))
                    object.iv = options.bytes === String ? $util.base64.encode(message.iv, 0, message.iv.length) : options.bytes === Array ? Array.prototype.slice.call(message.iv) : message.iv;
                if (message.encryptedContent != null && message.hasOwnProperty("encryptedContent"))
                    object.encryptedContent = options.bytes === String ? $util.base64.encode(message.encryptedContent, 0, message.encryptedContent.length) : options.bytes === Array ? Array.prototype.slice.call(message.encryptedContent) : message.encryptedContent;
                var keys2;
                if (message.decryptors && (keys2 = Object.keys(message.decryptors)).length) {
                    object.decryptors = {};
                    for (var j = 0; j < keys2.length; ++j)
                        object.decryptors[keys2[j]] = options.bytes === String ? $util.base64.encode(message.decryptors[keys2[j]], 0, message.decryptors[keys2[j]].length) : options.bytes === Array ? Array.prototype.slice.call(message.decryptors[keys2[j]]) : message.decryptors[keys2[j]];
                }
                return object;
            };
            /**
             * Converts this RecipientStatusObject to JSON.
             * @function toJSON
             * @memberof vereign.statuses.RecipientStatusObject
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            RecipientStatusObject.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };
            return RecipientStatusObject;
        })();
        statuses.WrapperData = (function () {
            /**
             * Properties of a WrapperData.
             * @memberof vereign.statuses
             * @interface IWrapperData
             * @property {Uint8Array|null} [data] WrapperData data
             * @property {number|null} [version] WrapperData version
             * @property {string|null} [className] WrapperData className
             */
            /**
             * Constructs a new WrapperData.
             * @memberof vereign.statuses
             * @classdesc Represents a WrapperData.
             * @implements IWrapperData
             * @constructor
             * @param {vereign.statuses.IWrapperData=} [properties] Properties to set
             */
            function WrapperData(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }
            /**
             * WrapperData data.
             * @member {Uint8Array} data
             * @memberof vereign.statuses.WrapperData
             * @instance
             */
            WrapperData.prototype.data = $util.newBuffer([]);
            /**
             * WrapperData version.
             * @member {number} version
             * @memberof vereign.statuses.WrapperData
             * @instance
             */
            WrapperData.prototype.version = 0;
            /**
             * WrapperData className.
             * @member {string} className
             * @memberof vereign.statuses.WrapperData
             * @instance
             */
            WrapperData.prototype.className = "";
            /**
             * Creates a new WrapperData instance using the specified properties.
             * @function create
             * @memberof vereign.statuses.WrapperData
             * @static
             * @param {vereign.statuses.IWrapperData=} [properties] Properties to set
             * @returns {vereign.statuses.WrapperData} WrapperData instance
             */
            WrapperData.create = function create(properties) {
                return new WrapperData(properties);
            };
            /**
             * Encodes the specified WrapperData message. Does not implicitly {@link vereign.statuses.WrapperData.verify|verify} messages.
             * @function encode
             * @memberof vereign.statuses.WrapperData
             * @static
             * @param {vereign.statuses.IWrapperData} message WrapperData message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            WrapperData.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.data != null && Object.hasOwnProperty.call(message, "data"))
                    writer.uint32(/* id 1, wireType 2 =*/ 10).bytes(message.data);
                if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                    writer.uint32(/* id 2, wireType 0 =*/ 16).int32(message.version);
                if (message.className != null && Object.hasOwnProperty.call(message, "className"))
                    writer.uint32(/* id 3, wireType 2 =*/ 26).string(message.className);
                return writer;
            };
            /**
             * Encodes the specified WrapperData message, length delimited. Does not implicitly {@link vereign.statuses.WrapperData.verify|verify} messages.
             * @function encodeDelimited
             * @memberof vereign.statuses.WrapperData
             * @static
             * @param {vereign.statuses.IWrapperData} message WrapperData message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            WrapperData.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };
            /**
             * Decodes a WrapperData message from the specified reader or buffer.
             * @function decode
             * @memberof vereign.statuses.WrapperData
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {vereign.statuses.WrapperData} WrapperData
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            WrapperData.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.statuses.WrapperData();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                        case 1:
                            message.data = reader.bytes();
                            break;
                        case 2:
                            message.version = reader.int32();
                            break;
                        case 3:
                            message.className = reader.string();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                    }
                }
                return message;
            };
            /**
             * Decodes a WrapperData message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof vereign.statuses.WrapperData
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {vereign.statuses.WrapperData} WrapperData
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            WrapperData.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };
            /**
             * Verifies a WrapperData message.
             * @function verify
             * @memberof vereign.statuses.WrapperData
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            WrapperData.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.data != null && message.hasOwnProperty("data"))
                    if (!(message.data && typeof message.data.length === "number" || $util.isString(message.data)))
                        return "data: buffer expected";
                if (message.version != null && message.hasOwnProperty("version"))
                    if (!$util.isInteger(message.version))
                        return "version: integer expected";
                if (message.className != null && message.hasOwnProperty("className"))
                    if (!$util.isString(message.className))
                        return "className: string expected";
                return null;
            };
            /**
             * Creates a WrapperData message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof vereign.statuses.WrapperData
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {vereign.statuses.WrapperData} WrapperData
             */
            WrapperData.fromObject = function fromObject(object) {
                if (object instanceof $root.vereign.statuses.WrapperData)
                    return object;
                var message = new $root.vereign.statuses.WrapperData();
                if (object.data != null)
                    if (typeof object.data === "string")
                        $util.base64.decode(object.data, message.data = $util.newBuffer($util.base64.length(object.data)), 0);
                    else if (object.data.length)
                        message.data = object.data;
                if (object.version != null)
                    message.version = object.version | 0;
                if (object.className != null)
                    message.className = String(object.className);
                return message;
            };
            /**
             * Creates a plain object from a WrapperData message. Also converts values to other types if specified.
             * @function toObject
             * @memberof vereign.statuses.WrapperData
             * @static
             * @param {vereign.statuses.WrapperData} message WrapperData
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            WrapperData.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    if (options.bytes === String)
                        object.data = "";
                    else {
                        object.data = [];
                        if (options.bytes !== Array)
                            object.data = $util.newBuffer(object.data);
                    }
                    object.version = 0;
                    object.className = "";
                }
                if (message.data != null && message.hasOwnProperty("data"))
                    object.data = options.bytes === String ? $util.base64.encode(message.data, 0, message.data.length) : options.bytes === Array ? Array.prototype.slice.call(message.data) : message.data;
                if (message.version != null && message.hasOwnProperty("version"))
                    object.version = message.version;
                if (message.className != null && message.hasOwnProperty("className"))
                    object.className = message.className;
                return object;
            };
            /**
             * Converts this WrapperData to JSON.
             * @function toJSON
             * @memberof vereign.statuses.WrapperData
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            WrapperData.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };
            return WrapperData;
        })();
        return statuses;
    })();
    return vereign;
})();
module.exports = $root;
